<?php
namespace Claromentis\Core\Acl\Simple;

$GLOBALS["__65da1b1ec" . "2d6653e8a0a" . "b7848e53621" . "5"] = (@$GLOBALS["__65da1b1ec2d6653e8a0ab7848e536" . "215"] ?: array()) + array("_938704c4c" . "0169c3804d" . "4bd6aa9941" . "a76" => base64_decode("Q2FuJ3QgbG9hZCBBQ0w6IG9iamVjdCBjb2RlIG5vdCB" . "zcGVjaWZpZWQ="), "_0877a0b48cf424" . "a0de57a453ce95e" . "30c" => base64_decode("aW50OnVzZXJfa" . "WQ="), "_3cda3f34ada928e4aa39" . "d4629c5504aa" => base64_decode("aW50O" . "nJpZ2" . "h0cw=" . "="), "_a7ed4d74" . "08bb99b87" . "a09d89d42" . "12d5de" => base64_decode("c2ltcGxlX2" . "FjbA=="), "_a8b22fed" . "b27a11e07" . "f5bb9a7c7" . "3608ea" => base64_decode("c3RyKDEwMCk6b2" . "JqZWN0X2NvZGU="), "_ef2948c87ef38aa" . "b9226e41189b29ca" . "7" => base64_decode("REVMRVRFIEZST00gc2ltcGxlX2FjbCBXSEVSRSBvYmplY3RfY29kZSBlcTpzdHI6" . "Y29kZQ=="), "_80fc2a45acd" . "0150df87d1fb" . "728940a60" => base64_decode("U0VMRUNUIHJpZ2h0cyBGUk9NIHNpbXBsZV9hY2wgV0hFUkUgb2JqZWN0X2NvZGUgZXE6c3RyOmNvZGUgQU5EIHVzZXJfaW" . "Q9aW50OnVpZA=="), "_84718d828d2a" . "cc3c366f96b07" . "e841f6a" => base64_decode("YWNsL" . "nNpbX" . "BsZQ=" . "="), "_b06968b9268deaf3b380" . "bd0fe922b453" => base64_decode("REVMRVRFIEZST00gc2ltcGxlX2FjbCBXSEVSRSBvYmp" . "lY3RfY29kZSBlcTpzdHI6Y29kZSBBTkQgdXNlcl9pZD" . "1pbnQ6dWlk"), "_c95cbc316178c97697a4" . "03f4d9124106" => base64_decode("U0VMRUNUIHVzZXJfaWQsIHJpZ2h0cyBGUk9NIHNpbXBsZV9hY2wgV0hFUkUgb2JqZWN0X2NvZGUgZXE6" . "c3RyOmNvZGU="), "_dbbe14f56769" . "3a631f8a43b65" . "af917ab" => base64_decode("Q2FuJ3QgZGVsZXRlIEFDTCBmcm9tIGRhdGFiYXNlOiBvYmplY3QgY29kZSBub3Qgc3BlY2l" . "maWVk"), "_27de5a4" . "5db71bf2" . "4058769b" . "61b3975a" . "3" => base64_decode("Q2FuJ3Qgc2F2ZSBBQ0w6IG9iamVjdCBjb2RlIG5vdC" . "BzcGVjaWZpZWQ="));
use Claromentis\Core\Acl\Exception\NoObjectException;
use Claromentis\Core\DAL;





class SimpleAclRepository
{
    private $db;
    public function __construct(DAL\Db $db)
    {
        $this->db = $db;
    }
    
    
    
    
    public static function I()
    {
        global $g_application;
        return $g_application[$GLOBALS["__65da1b1ec2d6653e8a0ab" . "7848e536215"]["_84718d828d2acc3c366" . "f96b07e841f6a"]];
    }
    public function IsGranted(string $_65c616d6ef3c21352d2d44595fdf776b, int $user_id, int $perms = SimpleAcl::STANDARD) : bool
    {
        if (!$user_id) {
            return false;
        }
        
        
        
        $_1f24efd4735b7a11b391147435e7d35d = $this->db->query($GLOBALS["__65da1b1ec2d6653e8a0ab7848e5362" . "15"]["_80fc2a45acd0150df8" . "7d1fb728940a60"], $_65c616d6ef3c21352d2d44595fdf776b, $user_id);
        if (!$_1f24efd4735b7a11b391147435e7d35d->hasData()) {
            return false;
        }
        list($p) = $_1f24efd4735b7a11b391147435e7d35d->fetchRow();
        return ($p & $perms) == $perms;
    }
    public function Grant(string $_65c616d6ef3c21352d2d44595fdf776b, int $user_id, int $perms = SimpleAcl::STANDARD)
    {
        $this->db->query(new DAL\QueryInsert($GLOBALS["__65da1b1ec2d6653e8a0" . "ab7848e536215"]["_a7ed4d7408bb" . "99b87a09d89d4" . "212d5de"], [$GLOBALS["__65da1b1ec2d6653e8a0ab784" . "8e536215"]["_a8b22fedb27a11e0" . "7f5bb9a7c73608ea"] => $_65c616d6ef3c21352d2d44595fdf776b, $GLOBALS["__65da1b1ec2d6653e8a0ab7848e5" . "36215"]["_0877a0b48cf424a0de57a453ce" . "95e30c"] => $user_id, $GLOBALS["__65da1b1ec2d6653e8a0" . "ab7848e536215"]["_3cda3f34ada928e4aa39d4629c550" . "4aa"] => $perms]));
    }
    public function Revoke(string $_65c616d6ef3c21352d2d44595fdf776b, int $user_id)
    {
        $this->db->query($GLOBALS["__65da1b1ec2d66" . "53e8a0ab7848e53" . "6215"]["_b06968b9268deaf3b380bd0fe922b" . "453"], $_65c616d6ef3c21352d2d44595fdf776b, $user_id);
    }
    
    
    
    
    
    
    
    
    public function Get(string $_65c616d6ef3c21352d2d44595fdf776b) : SimpleAcl
    {
        $acl = new SimpleAcl($_65c616d6ef3c21352d2d44595fdf776b);
        $this->Load($acl);
        return $acl;
    }
    
    
    
    
    
    
    public function Load(SimpleAcl $acl)
    {
        if (!$acl->GetObjectCode()) {
            throw new NoObjectException($GLOBALS["__65da1b1" . "ec2d6653e" . "8a0ab7848" . "e536215"]["_938704c4c0169c3" . "804d4bd6aa9941a7" . "6"]);
        }
        $acl->Clear();
        $_1f24efd4735b7a11b391147435e7d35d = $this->db->query($GLOBALS["__65da1b1ec2d6653e8a0ab784" . "8e536215"]["_c95cbc316178" . "c97697a403f4d" . "9124106"], $acl->GetObjectCode());
        while (list($user_id, $perms) = $_1f24efd4735b7a11b391147435e7d35d->fetchRow()) {
            $acl->Set($user_id, $perms);
        }
    }
    
    
    
    
    public function Save(SimpleAcl $acl)
    {
        if (!$acl->GetObjectCode()) {
            throw new NoObjectException($GLOBALS["__65da1b1ec2d6653" . "e8a0ab7848e536215"]["_27de5a45" . "db71bf240" . "58769b61b" . "3975a3"]);
        }
        $this->Delete($acl);
        $_65c616d6ef3c21352d2d44595fdf776b = $acl->GetObjectCode();
        foreach ($acl->GetRights() as $user_id => $perms) {
            if ($perms) {
                $this->Grant($_65c616d6ef3c21352d2d44595fdf776b, $user_id, $perms);
            }
        }
    }
    
    
    
    
    
    
    public function Delete(SimpleAcl $acl)
    {
        if (!$acl->GetObjectCode()) {
            throw new NoObjectException($GLOBALS["__65da1b1ec2d6653e8a0ab78" . "48e536215"]["_dbbe14f5676" . "93a631f8a43b" . "65af917ab"]);
        }
        $this->db->query($GLOBALS["__65da1b1ec2d6653e8a0ab7" . "848e536215"]["_ef2948c87ef38aab9226e41189" . "b29ca7"], $acl->GetObjectCode());
    }
}